.386p
codeseg segment use16
    org 1000h                 ;߱ص1000
    jmp start                 ;ĹPIOʽȡӲ0ݣʾĻ

buffer      db      512 dup (0)                    ;׼һݻ
count       dw      0							   ;ͳ
ide_command_base_addr      equ    01f0h            ;IDE豸ģĴַ

;***************************Ĵַ****************************************
;      Port    Read/Write   Misc
;    --------  ----------   ------------------------------------
;       1f0       r/w       data register, the bytes are written/read here
;       1f1       r         error register  (look these values up yourself)
;       1f2       r/w       sector count, how many sectors to read/write
;       1f3       r/w       sector number, the actual sector wanted
;       1f4       r/w       cylinder low, cylinders is 0-1024
;       1f5       r/w       cylinder high, this makes up the rest of the 1024
;       1f6       r/w       drive/head
;                              bit 7 = 1
;                              bit 6 = 0
;                              bit 5 = 1
;                              bit 4 = 0  drive 0 select
;                                    = 1  drive 1 select
;                              bit 3-0    head select bits
;       1f7       r         status register
;                              bit 7 = 1  controller is executing a command
;                              bit 6 = 1  drive is ready
;                              bit 5 = 1  write fault
;                              bit 4 = 1  seek complete
;                              bit 3 = 1  sector buffer requires servicing
;                              bit 2 = 1  disk data read corrected
;                              bit 1 = 1  index - set to 1 each revolution
;                              bit 0 = 1  previous command ended in an error
;       1f7       w         command register
;                            commands:
;                              50h format track
;                              20h read sectors with retry
;                              21h read sectors without retry
;                              22h read long with retry
;                              23h read long without retry
;                              30h write sectors with retry
;                              31h write sectors without retry
;                              32h write long with retry
;                              33h write long without retry
;
;  Most of these should work on even non-IDE hard disks.   
;*****************************************************************************
start:

    mov ax, cs                                   ;ȫ0
	mov ds, ax
	mov es, ax
	mov ss, ax
	mov sp, 7c00h
	
	                                             ;ͷ

                                                 ;

                                                 ;ȡ
                            
                                                 ;ĵ8λ

                                                 ;ĸ8λ

                                                 ;д֣
                                                 
                                                 ;ѯIDE豸״̬æʱȴ
                                                 
                                                 ;ȡIDE豸ݶ˿Ϣݻbuffer

;***************************ӡ*********************************    
ShowBuffer:
    lea     si,offset buffer                     ;ʾbufferݣ涨Ļ
    cld
    mov     bp,24                                ;24

NextLine:       
    mov     cx,22                                ;ÿʾ16ֽڵ

NextCh:         
    lodsb
    push ax

    shr al, 4                                    ;߼ƣʾah
    mov bx, 0
    mov ah, 0eh
    call ToASCII
    
    int 10h
    pop ax                                       ;ʾalе
    mov ah, 0eh
    call ToASCII
    int 10h
    
    mov al, ' '                                  ;ո
    int 10h
    
    mov dx, count                                ;512ֽںתѭ
    add dx, 1
    mov count, dx
    cmp dx, 512
    je over

    loop    NextCh                               ;ѭ

    mov al, 0dh                                  ;
    int 10h
    
    mov al, 0ah                                  ;س
    int 10h

    dec     bp                                   ;ѭ
    jnz     NextLine

over:
    pop dx
    jmp over                                     ;ѭ      

ToASCII:                                         ;ַתASCII
    and     al,0fh
    cmp     al,10
    jae     Over10
    add     al,'0'
    ret

Over10:
    add     al,'A'-10
    ret	

codeseg  ends
end
